Index: /data/trunk/levels/sp_level_moonstation.oxw
===================================================================
--- /data/trunk/levels/sp_level_moonstation.oxw	(revision 4887)
+++ /data/trunk/levels/sp_level_moonstation.oxw	(revision 4888)
@@ -114,25 +114,45 @@
 	<Mover>
 		<name>door_aircleaning</name>
+		<bReopen>1</bReopen>
+		<bReclose>1</bReclose>
 		<model>models/doors/door_small_b.obj, 6.7</model><!-- modelpath, size -->
 		<abs-dir>3.141, 0, 1, 0</abs-dir><!-- Pi,,Y-Axis-Rotation, -->
 		<abs-coor>120, 160, 320</abs-coor>
-		<rel-target-coor>0, 0, -45</rel-target-coor>
-		<action-time>0.6</action-time>
-		<action-radius>50.0</action-radius>
-		<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
-		<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+		<triggers>
+			<ApproachTrigger>
+				<radius>50</radius>
+			</ApproachTrigger>
+		</triggers>
+		<stations>
+			<MoverStation>
+				<moving-time>0.6</moving-time>
+				<rel-target-coor>0, 0, -45</rel-target-coor>
+				<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+				<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+			</MoverStation>
+		</stations>
 	</Mover>
 		
 	<Mover>
 		<name>door_lager</name>
+		<bReopen>1</bReopen>
+		<bReclose>1</bReclose>
 		<model>models/doors/door_blue_big.obj, 19</model><!-- modelpath, size -->
 		<abs-dir>1.57, 0, 1, 0</abs-dir><!-- Pi,,Y-Axis-Rotation, -->
 		<abs-coor>-65, 128, -161.1</abs-coor>
-		<rel-target-coor>0, 92.5, 0</rel-target-coor>
-		<action-time>1.2</action-time>
-		<action-radius>130</action-radius>
-		<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
-		<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
-		<closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+		<triggers>
+			<ApproachTrigger>
+				<radius>130</radius>
+			</ApproachTrigger>
+		</triggers>
+		<stations>
+			<MoverStation>
+				<moving-time>1.2</moving-time>
+				<rel-target-coor>0, 92.5, 0</rel-target-coor>
+				<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+				<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+				<closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+			</MoverStation>
+		</stations>
 	</Mover>		
 		
@@ -314,22 +334,42 @@
 	<Mover>
 		<name>door_sleepingroom_l</name>
+		<bReopen>1</bReopen>
+		<bReclose>1</bReclose>
 		<model>models/doors/door_small_b.obj, 6.2</model><!-- modelpath, size -->
 		<abs-dir>1.57, 0, 1, 0</abs-dir><!-- Pi,,Y-Axis-Rotation, -->
 		<abs-coor>405.5, 160, 175</abs-coor>
-		<rel-target-coor>31, 0, 0</rel-target-coor>
-		<action-time>0.6</action-time>
-		<action-radius>50.0</action-radius>
-		<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
-		<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
-		<!--<closed-sound>sounds/doors/door_closed2.wav</closed-sound>-->
+		<triggers>
+			<ApproachTrigger>
+				<radius>50</radius>
+			</ApproachTrigger>
+		</triggers>
+		<stations>
+			<MoverStation>
+				<moving-time>0.6</moving-time>
+				<rel-target-coor>31, 0, 0</rel-target-coor>
+				<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+				<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+				<!--<closed-sound>sounds/doors/door_closed2.wav</closed-sound>-->
+			</MoverStation>
+		</stations>
 	</Mover>
 	<Mover>
 		<name>door_sleepingroom_r</name>
+		<bReopen>1</bReopen>
+		<bReclose>1</bReclose>
 		<model>models/doors/door_small_b.obj, 6.2</model><!-- modelpath, size -->
 		<abs-dir>1.57, 0, -1, 0</abs-dir><!-- Pi,,Y-Axis-Rotation, -->
 		<abs-coor>362, 160, 175</abs-coor>
-		<rel-target-coor>-31, 0, 0</rel-target-coor>
-		<action-time>0.6</action-time>
-		<action-radius>50.0</action-radius>
+		<triggers>
+			<ApproachTrigger>
+				<radius>50</radius>
+			</ApproachTrigger>
+		</triggers>
+		<stations>
+			<MoverStation>
+				<moving-time>0.6</moving-time>
+				<rel-target-coor>-31, 0, 0</rel-target-coor>
+			</MoverStation>
+		</stations>
 	</Mover>
 	
@@ -391,13 +431,23 @@
 	<Mover>
 		<name>door_elevator</name>
+		<bReopen>1</bReopen>
+		<bReclose>1</bReclose>
 		<model>models/doors/door_small_b.obj, 10</model><!-- modelpath, size -->
 		<abs-dir>1.57, 0, 1, 0</abs-dir><!-- Pi,,Y-Axis-Rotation, -->
 		<abs-coor>210, -810, -454</abs-coor>
-		<rel-target-coor>60, 0, 0</rel-target-coor>
-		<action-time>0.6</action-time>
-		<action-radius>50.0</action-radius>
-		<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
-		<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
-		<!--<closed-sound>sounds/doors/door_closed2.wav</closed-sound>-->
+		<triggers>
+			<ApproachTrigger>
+				<radius>50</radius>
+			</ApproachTrigger>
+		</triggers>
+		<stations>
+			<MoverStation>
+				<moving-time>0.6</moving-time>
+				<rel-target-coor>60, 0, 0</rel-target-coor>
+				<opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+				<closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+				<!--<closed-sound>sounds/doors/door_closed2.wav</closed-sound>-->
+			</MoverStation>
+		</stations>
 	</Mover>
 		
Index: /data/trunk/levels/sp_level_spacestation1.oxw
===================================================================
--- /data/trunk/levels/sp_level_spacestation1.oxw	(revision 4887)
+++ /data/trunk/levels/sp_level_spacestation1.oxw	(revision 4888)
@@ -94,54 +94,104 @@
     <Mover>
       <name>hangar1_u</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_up.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>0, 87, -672</abs-coor>
-      <rel-target-coor>0, 70, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 70, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+        </MoverStation>
+      </stations>
     </Mover>
     <Mover>
       <name>hangar1_d</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_down.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>0, 87, -672</abs-coor>
-      <rel-target-coor>0, -64, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
-      <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
-      <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
-      <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
-      <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, -64, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
     </Mover>
     <Mover>
       <name>hangar1_l</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_left.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>0, 87, -672</abs-coor>
-      <rel-target-coor>-62.5, 0, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>-62.5, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+        </MoverStation>
+      </stations>
     </Mover>
     <Mover>
       <name>hangar1_r</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_right.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>0, 87, -672</abs-coor>
-      <rel-target-coor>62.5, 0, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>62.5, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+        </MoverStation>
+      </stations>
     </Mover>
 
     <Mover>
       <name>room_door</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door_small_b.obj, 9.5</model>
       <abs-dir>3.1412 , 0, 1, 0</abs-dir>
       <abs-coor>-636, 48, 0</abs-coor>
-      <rel-target-coor>0, 0, 68</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>100.0</action-radius>
-      <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
-      <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
-      <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+      <triggers>
+        <ApproachTrigger>
+          <radius>100</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 0, 68</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
     </Mover>
 
Index: /data/trunk/levels/sp_level_spacestation1B.oxw
===================================================================
--- /data/trunk/levels/sp_level_spacestation1B.oxw	(revision 4887)
+++ /data/trunk/levels/sp_level_spacestation1B.oxw	(revision 4888)
@@ -71,43 +71,84 @@
     </ModelEntity>
 
+
     <Mover>
       <name>hangar1_u</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_up.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>4480, 87, -4032</abs-coor>
-      <rel-target-coor>0, 70, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 70, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+        </MoverStation>
+      </stations>
     </Mover>
     <Mover>
       <name>hangar1_d</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_down.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>4480, 87, -4032</abs-coor>
-      <rel-target-coor>0, -64, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
-      <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
-      <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
-      <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
-      <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, -64, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
     </Mover>
     <Mover>
       <name>hangar1_l</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_left.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>4480, 87, -4032</abs-coor>
-      <rel-target-coor>-62.5, 0, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>-62.5, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+        </MoverStation>
+      </stations>
     </Mover>
     <Mover>
       <name>hangar1_r</name>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
       <model>models/doors/door1b_right.obj, 26</model>
       <abs-dir>1.57, -1, 0, 0</abs-dir>
       <abs-coor>4480, 87, -4032</abs-coor>
-      <rel-target-coor>62.5, 0, 0</rel-target-coor>
-      <action-time>0.75</action-time>
-      <action-radius>150.0</action-radius>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>62.5, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+        </MoverStation>
+      </stations>
     </Mover>
 